#include "Arduino.h"
#include "TTP229L_I2C.h"
#define DeviceADDR 0xAF 
int scl_ttp = A5;
int sda_ttp = A4;

#define debugKs0260 false

void TTP229_i2c_start(void) {
  if (debugKs0260)
    Serial.println("ttp229_iic_start");
  pinMode(scl_ttp, OUTPUT);
  pinMode(sda_ttp, OUTPUT);
  digitalWrite(scl_ttp, HIGH);
  digitalWrite(sda_ttp, HIGH);
  delayMicroseconds(10);
  digitalWrite(sda_ttp, LOW);
  delayMicroseconds(10);
  digitalWrite(scl_ttp, LOW);
}

void TTP229_i2c_stop(void) {
  if (debugKs0260)
    Serial.println("ttp229_iic_stop");
  pinMode(scl_ttp, OUTPUT);
  pinMode(sda_ttp, OUTPUT);
  digitalWrite(sda_ttp, LOW);
  digitalWrite(scl_ttp, LOW);
  delayMicroseconds(10);
  digitalWrite(scl_ttp, HIGH);
  delayMicroseconds(10);
  digitalWrite(sda_ttp, HIGH);
  delayMicroseconds(10);
}

void TTP229_i2c_Mack(void) {
  if (debugKs0260)
    Serial.println("ttp229_iic_Mack");
  pinMode(scl_ttp, OUTPUT);
  pinMode(sda_ttp, OUTPUT);
  digitalWrite(scl_ttp, LOW);
  digitalWrite(sda_ttp, HIGH);
  delayMicroseconds(10);
  digitalWrite(sda_ttp, LOW);
  digitalWrite(scl_ttp, HIGH);
  delayMicroseconds(10);
  digitalWrite(scl_ttp, LOW);
  digitalWrite(sda_ttp, HIGH);
}


void TTP229_i2c_Sack(void) {
  if (debugKs0260)
    Serial.println("ttp229_iic_Sack");
  pinMode(scl_ttp, OUTPUT);
  pinMode(sda_ttp, INPUT);

  digitalWrite(scl_ttp, HIGH);
  digitalWrite(scl_ttp, LOW);
  delayMicroseconds(10);
  digitalWrite(scl_ttp, HIGH);
  while (HIGH == digitalRead(sda_ttp))
    ;  //等待从机应答
}

void TTP229_i2c_Mnack(void) {
  if (debugKs0260)
    Serial.println("ttp229_iic_Mnack");
  pinMode(scl_ttp, OUTPUT);
  pinMode(sda_ttp, OUTPUT);
  digitalWrite(scl_ttp, LOW);
  digitalWrite(sda_ttp, LOW);
  delayMicroseconds(10);
  digitalWrite(sda_ttp, HIGH);
  digitalWrite(scl_ttp, HIGH);
  delayMicroseconds(10);
  digitalWrite(scl_ttp, LOW);
  digitalWrite(sda_ttp, LOW);
  delayMicroseconds(10);
}

int TTP229_i2c_rbit(void) {
  int Dat = 0;
  if (debugKs0260)
    Serial.println("ttp229_iic_rbit");
  pinMode(scl_ttp, OUTPUT);
  pinMode(sda_ttp, INPUT);
  for (char a = 0; a < 8; a++) {
    digitalWrite(scl_ttp, LOW);
    delay(5);
    digitalWrite(scl_ttp, HIGH);
    if (digitalRead(sda_ttp) == HIGH) {
      Dat = (Dat << 1) | 1;
    } else {
      Dat = Dat << 1;
    }
    delayMicroseconds(10);
  }
  return Dat;
}

void TTP229_i2c_wbit(int dat) {
  if (debugKs0260)
    Serial.println("ttp229_iic_wbit");
  pinMode(scl_ttp, OUTPUT);
  pinMode(sda_ttp, OUTPUT);
  for (char i = 0; i < 8; i++) {
    digitalWrite(scl_ttp, LOW);
    if ((0x80 & dat) == 0x80)
      digitalWrite(sda_ttp, HIGH);
    else
      digitalWrite(sda_ttp, LOW);
    digitalWrite(scl_ttp, HIGH);
    delayMicroseconds(20);
    dat = dat << 1;
  }
  digitalWrite(sda_ttp, HIGH);  //释放数据总线
  digitalWrite(scl_ttp, HIGH);
}

unsigned int TTP229_i2c_read(void) {
  unsigned int Hdat;
  unsigned int Ldat;
  TTP229_i2c_start();
  TTP229_i2c_wbit(DeviceADDR);
  TTP229_i2c_Sack();
  Ldat = TTP229_i2c_rbit();
  TTP229_i2c_Mack();
  Hdat = TTP229_i2c_rbit();
  Hdat = Hdat << 8;
  TTP229_i2c_Mnack();
  TTP229_i2c_stop();
  //return Ldat;
  return Hdat + Ldat;
}

